> For the complete documentation index, see [llms.txt](https://developers.frontstream.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.frontstream.com/welcome-to-our-payment-api/api-references/test-payment-api-features/each-api-reference-specifics/returns.md).

# Returns

## POST /api/refund

> Make a refund

```json
{"openapi":"3.0.1","info":{"title":"The Payment API","version":"v1"},"paths":{"/api/refund":{"post":{"tags":["Returns"],"summary":"Make a refund","parameters":[{"name":"AccessToken","in":"header","description":"access token","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/RefundRequest"}},"application/json":{"schema":{"$ref":"#/components/schemas/RefundRequest"}},"text/json":{"schema":{"$ref":"#/components/schemas/RefundRequest"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/RefundRequest"}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RefundResponse"}}}},"400":{"description":"Failure","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/BrokenRule"}}}}}}}}},"components":{"schemas":{"RefundRequest":{"required":["Reason"],"type":"object","properties":{"ProcessorGuid":{"type":"string","description":"optional for Non-Profit transactions like donations but required if For-Profit API Partner - Identifies Processor being used by an API Partner","nullable":true},"CharityId":{"type":"string","description":"optional - Valid CharityId Guid from Charity Search","nullable":true},"OrganizationGuid":{"type":"string","description":"internal use - Valid Panorama Organization Guid","nullable":true},"IntegrationSource":{"type":"string","description":"internal use - Identifies integrated Product","nullable":true},"PaymentGuid":{"type":"string","description":"optional if not using PaymentExternalId - Payment API PaymentGuid to be refunded","nullable":true},"PaymentExternalId":{"maxLength":200,"type":"string","description":"optional (max: 200) if not using PaymentGuid - 3rd Party Payment External Id to be refunded","nullable":true},"Reason":{"maxLength":500,"type":"string","description":"required - reason for refund request"}},"additionalProperties":false,"description":""},"RefundResponse":{"type":"object","properties":{"Successful":{"type":"boolean","description":"\"true\" if the transaction was processed successfully, and \"false\" if the transaction was not processed successfully."},"Message":{"type":"string","nullable":true},"ProcessorMessage":{"type":"string","nullable":true},"TransactionId":{"type":"string","nullable":true},"OriginalTransactionId":{"type":"string","nullable":true},"PaymentGuid":{"type":"string","format":"uuid"},"PaymentId":{"type":"integer","format":"int32"},"ResponseCode":{"type":"string","nullable":true},"PaymentResult":{"$ref":"#/components/schemas/PaymentResult"},"ProcessStatus":{"$ref":"#/components/schemas/ProcessStatus"}},"additionalProperties":false,"description":""},"PaymentResult":{"enum":[1,2,3,4,5,6],"type":"integer","format":"int32"},"ProcessStatus":{"enum":[1,2,3,4,5,6,7,8,9,10,11,12],"type":"integer","format":"int32"},"BrokenRule":{"type":"object","properties":{"ErrorCode":{"type":"integer","format":"int32"},"Message":{"type":"string","nullable":true},"LoggerMessage":{"type":"string","nullable":true}},"additionalProperties":false}}}}
```

## POST /api/void

> Make a void

```json
{"openapi":"3.0.1","info":{"title":"The Payment API","version":"v1"},"paths":{"/api/void":{"post":{"tags":["Returns"],"summary":"Make a void","parameters":[{"name":"AccessToken","in":"header","description":"access token","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/VoidRequest"}},"application/json":{"schema":{"$ref":"#/components/schemas/VoidRequest"}},"text/json":{"schema":{"$ref":"#/components/schemas/VoidRequest"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/VoidRequest"}}}},"responses":{"200":{"description":"Success","content":{"application/json":{"schema":{"$ref":"#/components/schemas/VoidResponse"}}}},"400":{"description":"Failure","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/BrokenRule"}}}}}}}}},"components":{"schemas":{"VoidRequest":{"required":["Reason"],"type":"object","properties":{"ProcessorGuid":{"type":"string","description":"optional for Non-Profit transactions like donations but required if For-Profit API Partner - Identifies Processor being used by an API Partner","nullable":true},"CharityId":{"type":"string","description":"optional - Valid CharityId Guid from Charity Search","nullable":true},"OrganizationGuid":{"type":"string","description":"internal use - Valid Panorama Organization Guid","nullable":true},"IntegrationSource":{"type":"string","description":"internal use - Identifies integrated Product","nullable":true},"PaymentGuid":{"type":"string","description":"optional - if not using PaymentExternalId - Payment API PaymentGuid to be refunded","nullable":true},"PaymentExternalId":{"maxLength":200,"type":"string","description":"optional (max: 200) - if not using PaymentGuid - 3rd Party Payment External Id to be refunded","nullable":true},"Reason":{"maxLength":500,"type":"string","description":"required - reason for void request"}},"additionalProperties":false,"description":""},"VoidResponse":{"type":"object","properties":{"Successful":{"type":"boolean","description":"\"true\" if the transaction was processed successfully, and \"false\" if the transaction was not processed successfully."},"Message":{"type":"string","nullable":true},"ProcessorMessage":{"type":"string","nullable":true},"TransactionId":{"type":"string","nullable":true},"OriginalTransactionId":{"type":"string","nullable":true},"PaymentGuid":{"type":"string","format":"uuid"},"PaymentId":{"type":"integer","format":"int32"},"ResponseCode":{"type":"string","nullable":true},"PaymentResult":{"$ref":"#/components/schemas/PaymentResult"},"ProcessStatus":{"$ref":"#/components/schemas/ProcessStatus"}},"additionalProperties":false,"description":""},"PaymentResult":{"enum":[1,2,3,4,5,6],"type":"integer","format":"int32"},"ProcessStatus":{"enum":[1,2,3,4,5,6,7,8,9,10,11,12],"type":"integer","format":"int32"},"BrokenRule":{"type":"object","properties":{"ErrorCode":{"type":"integer","format":"int32"},"Message":{"type":"string","nullable":true},"LoggerMessage":{"type":"string","nullable":true}},"additionalProperties":false}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.frontstream.com/welcome-to-our-payment-api/api-references/test-payment-api-features/each-api-reference-specifics/returns.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
